#include <iostream.h>
#include <string.h>
#include <conio.h>

class EXPRESSION
{
   private:  char infix[20];
	     char postfix[20];
	     char stack[20];
	     int top;

   public :  EXPRESSION()    //constructor
	     {
		 top = -1;
		 strset(postfix,'\0');
		 strset(stack, '\0');
	     }
	     void getINFIX(void);
	     void infix_to_postfix(void);
	     void push (char symb);
	     int  pop ();
	     int  preced(char symb);
	     void putPOSTFIX(void);
};

void EXPRESSION :: getINFIX(void)
{
    cout<<"Enter a valid infix expression"<<endl;
    cin>>infix;
}
void EXPRESSION ::infix_to_postfix (void)
{
	int length;
	int index = 0, pos = 0;
	char symbol,temp;

	length = strlen(infix);
	push ('#');

	while (index < length)
	{
		symbol = infix[index];

		switch (symbol)
		{
			case '(' : push (symbol);
				   break;
			case ')' : temp = pop();
				   while (temp != '(')
				   {
					postfix[pos] = temp;
					pos++;
					temp = pop();
				   }
				   break;
			case '+' :
			case '-' :
			case '*' :
			case '/' :
			case '^' : while (preced(stack[top]) >= preced(symbol))
				   {
				      temp = pop();
				      postfix[pos] = temp;
				      pos++;
				   }
				   push (symbol);
				   break;
			default : postfix[pos++] = symbol;
				  break;
		}
		index++;
	}
	while (top > 0)
	{
	   temp = pop();
	   postfix[pos++] = temp;
	}
	return;
}

void EXPRESSION::push (char symb)
{
	top = top + 1;
	stack[top] = symb;
}
int EXPRESSION::pop ()
{
	char symb;
	symb = stack[top];
	top = top - 1;
	return(symb);
}

int EXPRESSION :: preced(char symb)
{
	int p;
	switch (symb)
	{
		case '^' : p = 3;
			   break;
		case '*' :
		case '/' : p = 2;
			   break;
		case '+' :
		case '-' : p = 1;
			   break;
		case ')' :
		case '(' : p = 0;
			   break;
		case '#' : p = -1;
			   break;
	}
	return (p);
}

void EXPRESSION :: putPOSTFIX(void)
{
    cout<<"Postfix expression is ";
    cout<<postfix<<endl;
}

void main ()
{
	EXPRESSION e;
	clrscr();

	e.getINFIX();
	e.infix_to_postfix ();
	e.putPOSTFIX();
}
/*------------------------------
Output
Enter a valid infix expression
(a+b)-(c*d)^(e/f)
Postfix expression is ab+cd*ef/^-

RUN2
Enter a valid infix expression
a*b-(c^d)+e/f
Postfix expression is ab*cd^-ef/+
------------------------------------*/
