
/* To create a template class QUEUE , with ADD & DELETE member
functions using it a queue of integers & doubles is implemented */

#include <iostream.h>
#include <iomanip.h>
#include <conio.h>


template <class T>
class queue
{
  public :
	   queue(int max = 4);   // Max size of queue is 4

	   ~queue()
	   {  delete [] pqptr; };

	   void insert(const T&) ;

	   int qfull() const
	   { return rear == nsize ; }

	   int qempty() const
	   { return (front >= rear || rear == 0) ; }

	   T del() ;

	   void display() ;

  private :
		int nsize;
		int rear;
		int front;
		T *pqptr;
} ;



template <class T>

queue <T> :: queue(int nx)
{
   nsize = nx > 0 && nx < 100 ? nx : 10 ;
   front = 0 ;
   rear = 0 ;
   pqptr = new T[nsize];
} ;



template <class T>

void queue <T> :: insert(const T &nitem)
{
   if (qfull())
   {
	 cout << "Queue overflow ....." << endl ;
	 getch();
	 return ;
   }
	 pqptr[++rear] = nitem ;
	 return ;
} ;



template <class T>

T queue <T> :: del(void)
{
	T p ;

	if (qempty())
	{
	   cout << "Queue empty ....." << endl;
	   getch();
	   return p ;
	}

	p = pqptr[front++];
	cout << "front " << front << " rear = " << rear ;
	return p ;
} ;



template <class T>

void queue <T> :: display()
{
   if (qempty())
   {
	  cout << "Empty queue......" << endl ;
	  getch();
	  return;
   }

   cout << "front =  " << front << " rear =  "  << rear << endl ;
   int i = front;

   cout << "\nFront ";

   for (i = i+1 ; i <= rear ; i++)
   {
	cout << " <- "  <<  pqptr[i] ;
   }

   cout << "<-Rear";

   return ;
} ;



int menu()
{
  int m ;

  cout << endl << setw(10) << "1. Insert";
  cout << endl << setw(10) << "2. Delete"; ;
  cout << endl << setw(11) << "3. Display";
  cout << endl << setw(8) <<  "4. Exit";

  cout << endl << endl << setw(9) << "Enter your choice : " ;
  cin >> m ;

  return m;
};

// * * * * * ** * * *  *   main * * * * ** ** ** * * * * * * *

void main(void)
{
  int menu();

  int choice1 = 0 , choice2 = 0 , i ;
  double d;

  queue <int> iq(4) ;
  queue <double> dq(4) ;

  clrscr();

  while (choice1 != 3)
  {
	choice1 = 0 ;

	cout << endl << setw(10) << " 1. Integer Queue";
	cout << endl << setw(10) << " 2. Double Queue" ;
	cout << endl << setw(7) <<  " 3. Exit";

	cout << endl << endl << setw(10) << "Enter your choice : " ;
	cin >> choice1 ;

	switch(choice1)
	{
	  case 1 : {
		     choice2 = 0 ;
		     while (choice2 != 4)
		     {
			 choice2 = menu();

			 switch(choice2)
			 {
			   case 1 : {  cout << endl
					    << "Enter the element to be inserted : " ;
					cin  >> i ;

					iq.insert(i);
					break;
				    }		 // insert

			   case 2 : {
					iq.del();
					break;
				    } 		// delete

			   case 3 : {
					iq.display();
					break;
				    } 		// display

			   case 4 : break ;

			   default : break;
			 }			//switch of choice2
		      }

		      break ;
		  }				// case 1


	  case 2 : {
		     choice2 = 0 ;

		     while (choice2 != 4)
		     {
			 choice2 = menu();
			 switch(choice2)
			 {
			      case 1 : {
					  cout << endl << "Enter the element to be inserted : " ;
					  cin >> d ;

					  dq.insert(d);
					  break;
				       }		 // insert

			      case 2 : {
					  dq.del();
					  break;
				       } 		// delete

			      case 3 : {
					  dq.display();
					  break;
					} 		// display

			      case 4 : break ;

			      default : break;
			}				//switch of choice2
		 }	  //while

		 break ;
	  } // case 2 of doubles


	  case 3 : break ;

	  default : break ;

      }	// switch of choice1

   }	// while
}	//main

/*----------------------------------------------
Output

 1. Integer Queue
 2. Double Queue
 3. Exit

Enter your choice : 1

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 1

Enter the element to be inserted : 10

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 1

Enter the element to be inserted : 1

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 20

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 1
Enter the element to be inserted : 30

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 3
front =  0 rear =  3

Front  <- 10 <- 20 <- 30<-Rear
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
front 1 rear = 3
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
front 2 rear = 3
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
front 3 rear = 3
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
Queue empty .....
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 4

 1. Integer Queue
 2. Double Queue
 3. Exit

Enter your choice : 2

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 1

Enter the element to be inserted : 12.45

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 1

Enter the element to be inserted : 34.56

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 1

Enter the element to be inserted : 45.67

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice :3
front =  0 rear =  3

Front  <- 12.45 <- 34.56 <- 45.67<-Rear
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
front 1 rear = 3
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
front 2 rear = 3
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
front 3 rear = 3
 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 2
Queue empty .....

 1. Insert
 2. Delete
 3. Display
 4. Exit

Enter your choice : 4

 1. Integer Queue
 2. Double Queue
 3. Exit

Enter your choice : 3
-----------------------------------------------*/

